unit babelform;
(*
   Esimerkki BabelFish-knnspalvelun (http://world.altavista.com)
   kytst Web-sovelluspalveluna.

   Alkuperinen versio: V. Lappalainen, 2001
      (Thanks to Ravenholm magazine 2/2001, page 17)

   Miika Nurminen, 14.9.2004

*)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, InvokeRegistry, Rio, SOAPHTTPClient;

type
  TFormFish = class(TForm)
    ComboBoxKielet: TComboBox;
    ButtonExec: TButton;
    MemoSource: TMemo;
    MemoTarget: TMemo;
    HTTPRIO: THTTPRIO;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonExecClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  (* Dummy string object box for use with TStrings *)
  TString = class(TObject)
    value:string;
  public
    constructor Create(value:string);
    destructor Destroy; override;
    function getValue:string;
  end;

var
  FormFish: TFormFish;

implementation

uses BabelFishService;

{$R *.dfm}

(*
  Koodi perustuu world.altavista.com:n etusivun html-koodiin. Jrkevmp
  olisi lukea tiedostosta tai (jos voidaan olettaa pysyv sivurakenne)
  jsent kentt suoraan HTML-tiedostosta.
*)
procedure TFormFish.FormCreate(Sender: TObject);
begin
  ComboBoxKielet.AddItem('Englannista hollantiin',TString.Create('en_nl'));
  ComboBoxKielet.AddItem('Englanti-ranska',TString.Create('en_fr'));
  ComboBoxKielet.AddItem('Englanti-saksa',TString.Create('en_de'));
  ComboBoxKielet.AddItem('Englanti-kreikka',TString.Create('en_el'));
  ComboBoxKielet.AddItem('Englanti-italia',TString.Create('en_it'));
  ComboBoxKielet.AddItem('Englanti-japani',TString.Create('en_ja'));
  ComboBoxKielet.AddItem('Englanti-korea',TString.Create('en_ko'));
  ComboBoxKielet.AddItem('Englanti-Portugali',TString.Create('en_pt'));
  ComboBoxKielet.AddItem('Englanti-Venj',TString.Create('en_ru'));
  ComboBoxKielet.AddItem('Englanti-espanja',TString.Create('en_es'));
  ComboBoxKielet.ItemIndex:=0;
end;

{ TString }

constructor TString.Create(value: string);
begin
  self.value := value;
  OutputDebugString('creating string');
end;

destructor TString.Destroy;
begin
  OutputDebugString('deleting string');
  inherited;
end;

function TString.getValue: string;
begin
  Result:=value;
end;

procedure TFormFish.FormDestroy(Sender: TObject);
var i:integer;
begin
  (*
     Delphi huolehtii merkkijonojen vapautuksesta, mutta listassa
     olevat TString-oliot tytyy vapauttaa ksin!
  *)
  for i:=0 to ComboBoxKielet.Items.Count-1 do begin
    ComboBoxKielet.Items.Objects[i].Free;
    ComboBoxKielet.Items.Objects[i]:=nil;
  end;
end;

procedure TFormFish.ButtonExecClick(Sender: TObject);
var Babel:BabelFishPortType;kieli:string;
begin
  FormFish.Caption := 'Knnetn....';
  try
    Babel := HTTPRIO as BabelFishPortType;

    kieli := (ComboBoxKielet.Items.Objects[ComboBoxKielet.ItemIndex] as TString).getValue;

    MemoTarget.Lines.Text := Babel.BabelFish(kieli,MemoSource.Text);
  except
    On E : Exception do MemoTarget.Lines.Text := E.Message;
  end;
  FormFish.Caption := 'Kala.';
end;

end.

